//@Name:Spearman Indicator
//@Description:As described on Stocks & Commodities magazine, February 2011 edition.

var period = 10;
var signal = 3;
function init()
{
	setSeriesColour(0, Colour.Red);
	setSeriesColour(1, Colour.Red);
	setSeriesLineStyle(1, Pen.Dot);
	setTitle("Spearman ("+period+", "+signal+" SMA)");
	setHorizontalLine(-80);
	setHorizontalLine(80);
}

function getGraph(share, data)
{
	var output = [];
	var sma = [];
	var ma1 = new MA(signal);
	var sequence;
	var sum;
	for (var i=period; i<data.length; i++)
	{
		sequence = [];
		sum = 0;
		for (var j=period-1;j>=0;j--)
		{
			sequence[j] = {value:data[i-j].close,rank:period-j};
		}
		sequence.sort(function (a,b){return a.value-b.value});
		for (j=0;j<sequence.length;j++)
		{
			sum += Math.pow(sequence[j].rank-(j+1),2);
		}
		output[i] = (1 - (6 * sum / (period * (Math.pow(period,2)-1)))) * 100;
		sma[i] = ma1.getNext(output[i]);
	}
	
	return [output,sma];
}